/* ========================================
 *BUS CAN TEST RECEPTION 
 *Laurent Proust
 * ========================================
*/
#include <device.h>
//initialisation de la variable contenant les données
// à recevoir
uint8 CAN_RX_Data=0;

//initialisation de la variable permettant de savoir si une données a été reçue
uint8 Reception_OK_CAN=0;

/*****************************
*         ATTENTION          *
******************************

Dans la fonction CAN_RX_TX_RX_func.c, il est nécessaire d'ajouter les lignes :

`#START TX_RX_FUNCTION`
extern uint8 CAN_TX_Data;
extern uint8 Reception_OK_CAN;
`#END` 
dans l'entête.

La fonction void CAN_RX_ReceiveMsgRX_Message(void) 
doit contenir

`#START MESSAGE_0_TRASMITTED` 
Reception_OK_CAN=1;
CAN_RX_Data=CAN_RX_RX_DATA_BYTE1(0);
`#END`
 
 *******************************/
void main()
{
   	char i=0;//déclaration variable de boucle
	
	/* Place your initialization/startup code here (e.g. MyInst_Start()) */
	
	CAN_RX_Start();//lancement controleur CAN
	LCD_Char_1_Start();//lancement afficheur
	CYGlobalIntEnable;/* Uncomment this line to enable global interrupts. */
	
	LCD_Char_1_PrintString("TEST BUSCAN RX");
	CyDelay(2000);//delai de 2s
	
	LCD_Char_1_ClearDisplay();//effacement écran
	LCD_Char_1_PrintString("DATA RX:");
	LCD_Char_1_Position(0,8);
    
    for(;;)
    {	
	
		if (Reception_OK_CAN==1)//si donnée reçue
		{
			i++;//détéction d'une réception
			LCD_Char_1_PutChar(CAN_RX_Data);//affichage de la donnée reçue
			Reception_OK_CAN=0;//annulation et préparation réception d'une nouvelle donnée
				if (i>=8)//initialisation position afficheur
				{LCD_Char_1_Position(0,8);LCD_Char_1_PrintString("        ");//effacement
				LCD_Char_1_Position(0,8);LCD_Char_1_PutChar(CAN_RX_Data);//affichage du dernier caractere reçu
				i=0;//réinitialisation de i
				}
		}	
    }
}

/* [] END OF FILE */